translateapp/accounts/urls.py
from django.urls import path
from . import views

app_name = "accounts"

urlpatterns = [
        path('dashboard', views.dashboard, name="dashboard"),
        path('profile/<int:user_id>', views.profile, name="profile"),
        path('register', views.register, name="register"),
]

translateapp/app/urls.py
from django.urls import path
from . import views

app_name = "app"
urlpatterns = [
        path('jobs', views.jobs_index, name="jobs"),
        path('jobs/new', views.new_job, name="new_job"),
        path('jobs/<int:job_id>', views.job_detail, name="job_detail"),
        path('jobs/<int:job_id>/bid', views.bid, name="bid"),
        path('bids/<int:bid_id>/accept', views.accept_bid, name="accept_bid"),
        path('bids/<int:bid_id>/deliver', views.deliver_translation, name="deliver_translation"),
        path('bids/<int:bid_id>', views.bid_detail, name="bid_detail"),
        path('bids/<int:bid_id>/rating', views.rate_bid, name="rate_bid"),
        path('bids/<int:bid_id>/dispute', views.raise_dispute, name="dispute"),
        path('message/<int:receiver_id>', views.send_message, name="send_message"),
]

translateapp/blog/urls.py
#
from django.urls import path, include

from . import views

app_name = "blog"

urlpatterns = [
    path('', views.blog, name="blog"),
    path('new', views.new_blog, name="new_blog"),
    path('posts/', views.posts, name='posts'),
    path('post/<int:post_id>/', views.post_detail, name='post_detail'),
    path('user_posts/<int:user_id>/', views.user_posts, name='user_posts'),
    path('edit_post/<int:blog_id>/', views.edit_post, name='edit_post'),
    path('delete_post/<int:blog_id>/', views.delete_post, name='delete_post'),]

translateapp/messenger/urls.py
from django.urls import path, include

from . import views

app_name = "messenger"

urlpatterns = [
    path('', views.messenger, name="messenger"),
    path('<int:user_id>', views.thread, name="thread"),
]

translateapp/translateapp/urls.py
#kopirala
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

from app import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', views.home, name='home_path'),
    path('app/', include('app.urls')),

#5.zadatak
    path('blog/', include('blog.urls')),


    path('messenger/', include('messenger.urls')),
    path('accounts/', include('accounts.urls')),
    path('accounts/', include('django.contrib.auth.urls'))
]
if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

translateapp/blog/models.py
from django.db import models

# Create your models here.

translateapp/blog/views.py
#za svaki html

from django.shortcuts import redirect, render
from django.core.exceptions import ObjectDoesNotExist

# Create your views here.
from django.shortcuts import render, get_object_or_404
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect
from django.urls import reverse

from app.models import Blog, Account
from django.contrib.auth.models import User

from app.forms import BlogForm

# Create your views here.

@login_required
def blog(request) :
    latest_posts = Blog.objects.order_by('-publish_date')[:5]
    context = {
        'latest_posts': latest_posts
        }
    
    return render(request, 'blog/blog_home.html', context)


@login_required
def new_blog(request):
    if request.method == 'POST':
        form = BlogForm(request.POST, request.FILES)
        if form.is_valid():
            blog_post = form.save(commit=False)
            blog_post.user = request.user
            blog_post.save()
            return HttpResponseRedirect(reverse('blog:posts'))
        else:  
            return render(request, 'blog/new_blog.html', {'form': form})
    else:
        form = BlogForm()
        context = {
            'form': form,
        }
        return render(request, 'blog/new_blog.html', context)

@login_required
def posts(request):
    posts = Blog.objects.all()
    context = {
        'posts': posts
        }
    return render(request, 'blog/posts.html', context)


@login_required
def post_detail(request, post_id):
    post = get_object_or_404(Blog, pk=post_id)
    
    
    context = {
        'post': post,
    }
    return render(request, 'blog/post_detail.html', context)






@login_required
def user_posts(request,user_id):
    user_post= Blog.objects.filter(user_id=user_id)
    return render(request, 'blog/user_posts.html', {'user_post':user_post})

def edit_post(request,blog_id):
    blog = get_object_or_404(Blog, id=blog_id)
    if request.method == 'POST':
        blog_form = BlogForm(request.POST,request.FILES ,instance=blog)
        if blog_form.is_valid():
            blog_form.save()
            return HttpResponseRedirect(reverse('blog:post_detail', args=[blog_id]))
    else:
        blog_form = BlogForm(instance=blog)
    
    context = {
        'blog_form': blog_form
        }
    return render(request, 'blog/edit_post.html', context)


def delete_post(request, blog_id):
    blog = get_object_or_404(Blog, id=blog_id)

    if request.method == 'POST':
        blog.delete()
        return HttpResponseRedirect(reverse('blog:blog'))
      
    return redirect('blog:post_detail', post_id=blog_id)

translateapp/blog/templates/blog/blog_home.html
{% extends 'app/base.html' %}

{% load static %}

<head>
    <link rel="stylesheet" href="{% static 'app/css/app.css' %}">
</head>

{% block content %}

    <h3 class="mb-3 mt-2">Blog Homepage</h3>

    <div class="blog-link">
        <a href="{% url 'blog:new_blog'  %}" class="btn custom-btn2 ms-3 mt-2 mb-5">Add new BlogPost</a>
        <a href="{% url 'blog:posts'  %}" class="btn custom-btn2 ms-3 mt-2 mb-5">All BlogPost</a>
    </div>

    <div class="container">
        <div class="table-responsive">
            <table class="table table-bordered custom-table">
                {% for post in latest_posts %}
                    <tr>
                        <td>
                            <h4><a href="{% url 'blog:post_detail' post.id %}" > {{ post.title }}</a></h4>
                            <h5>Created by: {{ post.user.account.name }}</h5>
                            <p>{{ post.text }}</p>
                            <p>Published on: {{ post.publish_date }}</p>
                        </td>
                    </tr>
                {% empty %}
                    <tr>
                        <td colspan="3">No available blog posts</td>
                    </tr>
                {% endfor %}
            </table>
        </div>
    </div>


{% endblock content %}

translateapp/blog/templates/blog/edit_post.html
{% extends 'app/base.html' %}

{% block content %}


<head>
    <title>Uredi Post</title>
</head>
<body>
    <h2>Uredi Post</h2>
    <form method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {{ blog_form.as_p }}
        <button type="submit">Spremi Promjene</button>
    </form>
    
</body>

{% endblock content %}

translateapp/blog/templates/blog/new_blog.html
{% extends 'app/base.html' %}

{% load widget_tweaks %}

{% block content %}
  <h1 class="mb-5 mt-5">Add new post</h1>
  <form method="post" enctype="multipart/form-data">
    {% csrf_token %}

    {% for hidden in form.hidden_fields %}
      {{ hidden }}
    {% endfor %}

    <div class="container">
      <div class="row">
        <div class="col-md-6">
          {% for field in form.visible_fields %}
            {% if field.label != "Text" %}
              <div class="form-group mt-3">
                <label for="{{ field.id_for_label }}">{{ field.label }}</label>
                {{ field|add_class:'form-control' }}
                {% for error in field.errors %}
                  <span class="help-block">{{ error }}</span>
                {% endfor %}
              </div>
            {% endif %}
          {% endfor %}

          <div class="form-group mt-4 mb-5">
            <button type="submit" class="btn custom-btn px-4 ">
              <span class="glyphicon glyphicon-ok"></span> Save
            </button>
            <a href="{% url 'home_path' %}" class="btn btn-default">Cancel</a>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group mt-3">
            <label for="{{ form.text.id_for_label }}">{{ form.text.label }}</label>
            {{ form.text|add_class:'form-control' }}
            {% for error in form.text.errors %}
              <span class="help-block">{{ error }}</span>
            {% endfor %}
          </div>
        </div>
      </div>
    </div>
    

  </form>
{% endblock %}

translateapp/blog/templates/blog/post_detail.html
{% extends 'app/base.html' %}

{% load static %}

{% block styles %}
<link rel="stylesheet" href="{% static 'app/css/app.css' %}">
{% endblock %}

{% block content %}
<div class="post-details" style=" background-color: lightgray;
width: 800px; margin-top: 10px;">
    <h1>Post Name: {{ post.title }}</h1>
    <div class="post-actions">
        <a href="{% url 'blog:edit_post' post.id %}" class="btn custom-btn2">Edit post</a>
        <form style="display: inline-block;" action="{% url 'blog:delete_post' post.id %}" method="post">
            {% csrf_token %}
            <button type="submit" class="btn btn-danger">Delete Post</button>
        </form>
        <br><br>
    </div>
    <div class="post-info">
        <h5>Created by: <a style=" color: black;" href="{% url 'accounts:profile' post.user.id %}">{{ post.user.account.name }}</a>
            <a href="{% url 'messenger:thread' post.user.id %}" style="background-color: gray;" class="btn custom-btn2">Message Post Owner</a>
        </h5>
        <p>{{ post.text }}</p>
        {% if post.blog_image %}
            <img src="{{ post.blog_image.url }}" alt="Image">
        {% endif %}
        <p style="text-align: right;">Published on: {{ post.publish_date }}</p>
    </div>

    

{% endblock %}

translateapp/blog/templates/blog/posts.html
{% extends 'app/base.html' %}

{% block content %}
    <h3 class="mb-3 mt-2">All Posts</h3>
    <div class="container">
        <div class="table-responsive">
            <table class="table table-bordered custom-table">
                {% for post in posts %}
                    <tr>
                        <td>
                            <h4><a href="{% url 'blog:post_detail' post.id %}" > {{ post.title }}</a></h4>

                            <h5>Created by: {{ post.user.account.name}}</h5>
                            <p>{{ post.text }}</p>
                            <p>Published on: {{ post.publish_date }}</p>

                        </td>
                    </tr>
                {% empty %}
                    <tr>
                        <td colspan="3">No available blog posts</td>
                    </tr>
                {% endfor %}
            </table>
        </div>
    </div>

{% endblock content %}

translateapp/blog/templates/blog/user_posts.html
{% extends 'app/base.html' %}
{% load static %}

<head>
    <link rel="stylesheet" href="{% static 'app/css/app.css' %}">
</head>

{% block content %}



    <div class="container">
        <div class="table-responsive">
            <table class="table table-bordered custom-table">
                <h5>Posts created by: {{ user_post.0.user.account.name }}</h5>
                {% for post in user_post %}
                    <tr>
                        <td>
                             {{ post.title }}</a></h4>
                            <p>{{ post.text }}</p>
                            <p>Published on: {{ post.publish_date }}</p>
                        </td>
                    </tr>
                {% empty %}
                    <tr>
                        <td colspan="3">No available blog posts</td>
                    </tr>
                {% endfor %}
            </table>
        </div>
    </div>


{% endblock content %}